/*****************************************************************************
	AmyEdit - A GTKMM LaTeX Editor
	Copyright (C) 2004-2005 Rob Page
	email:  page <dot> rob <at> gmail <dot> com

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*****************************************************************************/

#ifndef _PREFERENCES_HH
#define _PREFERENCES_HH

#include <gtkmm/dialog.h>
#include <gtkmm/label.h>
#include <gtkmm/spinbutton.h>
#include <gtkmm/alignment.h>

#include "PrefStruct.hh"
#include "TextListViewComboBox.hh"

class Preferences : public Gtk::Dialog
{

public:
	Preferences();
	~Preferences();
	int run();
private:

    TextListViewComboBox *languageslist;
    Gtk::SpinButton *tabsizebutton;
	Gtk::CheckButton *highlightbutton;
	Gtk::CheckButton *spacesinfilesbutton;
	TextListViewComboBox *previewoptionslist;
	void edit_latex_commands();

public:
	static Gtk::Widget *new_heading(Glib::ustring text);
	static Gtk::Widget *new_item(Glib::ustring text, Gtk::Widget *widget, bool fill=false, bool ralign=false);
	static Gtk::Widget *new_button(Glib::ustring text, sigc::slot<void> fn_slot);

private:
	class EditLatexCommands : public Gtk::Dialog
	{
		public:
			EditLatexCommands(Preferences* parent);
			int run();
		private:
			
			void on_add_clicked();
			void on_remove_clicked();
			void on_combo_changed();
			void on_help_clicked();

			void update_command(Glib::ustring command);
			void set_entrys(Glib::ustring command);

			Glib::ustring last_combo;
	
			TextListViewComboBox* combobox;
			Gtk::Entry* cmd_entry;
			Gtk::Entry* preview_entry;
			Gtk::Entry* output_entry;
	};

};

#endif  // _PREFERENCES_HH

