/*****************************************************************************
	AmyEdit - A GTKMM LaTeX Editor
	Copyright (C) 2004-2006 Rob Page
	email:  page <dot> rob <at> gmail <dot> com

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *****************************************************************************/

#ifndef _TEXTLISTMODEL_H
#define _TEXTLISTMODEL_H

#include <gtkmm/liststore.h>

class TextListModel : public Gtk::ListStore
{
	public:
		Gtk::TreeModel::Row append();
		Gtk::TreeModel::Row append(const Glib::ustring& text, bool allow_duplicates = false);
		void set_value(const Glib::ustring& text, Gtk::TreeModel::Row row, int column = 0, bool allow_duplicates = false);
		Glib::ustring get_value(const TextListModel::iterator& iter, int column = 0);
		TextListModel::iterator find_value(const Glib::ustring& text, int column = 0);
		
		const Gtk::TreeModelColumn<Glib::ustring> get_column(int column = 0);
		
		static Glib::RefPtr<TextListModel> create(int columns = 1);

	protected:
		TextListModel(int columns);
		
		class TextListColumn : public Gtk::TreeModel::ColumnRecord
		{
			public:
				TextListColumn(int columns);
				~TextListColumn();
				Gtk::TreeModelColumn<Glib::ustring> *col;
		} data;

		
};

#endif

