/*****************************************************************************
	AmyEdit - A GTKMM LaTeX Editor
	Copyright (C) 2004-2005 Rob Page
	email:  page <dot> rob <at> gmail <dot> com

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 *****************************************************************************/

#ifndef _TEXTLISTVIEWLISTBOX_HH
#define _TEXTLISTVIEWLISTBOX_HH

#include <gtkmm/treeview.h>

#include "Interfaces.hh"
#include "TextListModel.hh"

class TextListViewListBox : public Gtk::TreeView, public Interfaces::TextListView
{  
	public:
		TextListViewListBox(int columns = 1);
		void show_column(const Glib::ustring& title="", int column = 0);
		void select_first();
		void select(const Glib::ustring& selection);
		Glib::ustring get_selected(int column = 0);
		Glib::RefPtr<TextListModel> get_model();
};
#endif
